﻿using AdventOfCode.Common;
using AdventOfCode.Models;
using System.Linq;

namespace AdventOfCode._2022.Day12
{
    [AOC(year: 2022, day: 12)]
    [IgnoreTestAnswer(AOCVersion.B)] //Run time is 1min 38sec 648ms for PartB
    public class Day12 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var map = new Heightmap(GetSplitInput());
            map.Traverse(_request.Version);
            map.Steps.ToList().ForEach(x => Info(x));
            _response.Answer = map.TotalSteps;

            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            //Only difference is done VIA AOCVersion variable
            //Run time is 1min 38sec 648ms for PartB, might want to optimize
            return ExecutePartA();
        }

    }
}
