﻿using AdventOfCode._2022.Models;
using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2022
{
    [AOC(year: 2022, day: 6)]
    public class Day6 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var input = GetSplitInput().First();

            var datastream = input.ToCharArray();
            for (int i = 4; i < datastream.Length; i++)
            {
                var prevChars = datastream.Skip(i - 4).Take(4);
                if (!HasDuplicates(prevChars))
                {
                    _response.Answer = i;
                    break;
                }
            }

            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var input = GetSplitInput().First();

            var datastream = input.ToCharArray();
            for (int i = 14; i < datastream.Length; i++)
            {
                var prevChars = datastream.Skip(i - 14).Take(14);
                if (!HasDuplicates(prevChars))
                {
                    _response.Answer = i;
                    break;
                }
            }

            return _response;
        }

        private bool HasDuplicates(IEnumerable<char> chars)
        {
            if (chars.Count() == chars.Distinct().Count())
                return false;
            return true;
        }
    }
}
